10   'MAGVAR: This program computes the path of a charged particle moving in              a variable magnetic field.
11 '
14 'Initialization of variables and data input.
20  DEFINT I-N
30 DIM R(300),  V(300), TT(300), PH(300), IX(300), IY(300)
35 DIM XX(300), YY(300), ZZ(300), VVZ(300), VV3(300)
40 INPUT "INITIAL SPEED: 1.0 = CIRCLE  ", VZSTR : INPUT "TIME INTERVAL =";DEL  
60 INPUT "HOW OFTEN SHOULD POSITION BE REPORTED?";N
70 INPUT "hOW MANY POSITIONS SHOULD BE REPORTED?";M
80 INPUT "DO YOU WANT OUTPUT PRINTED ON PAPER? Y OR N";P$
90 INPUT "SET SCALE FACTOR FOR PLOTTING. 1 WORKS WELL FOR A CIRCLE.";S
95 INPUT "CHOOSE THE ANGLE BETWEEN PLOTTED VELOCITY VECTORS (DEGREES)";VANG  
110 J=0 : THTN=0 : PI=3.141592659# : PHIN=PI/2 : RN=1! : VN = VZSTR : VANG = VANG*PI/180  
120 VX = 0! : VY = VN: VZ = .5
130 X = -RN : Y = 0!: Z = 0
300 LLN = 0
1000 '
1010 'Print out the input data.
1015 PRINT "VN      DEL": PRINT USING "#.###   ";VN,DEL
1020 IF P$="Y" OR P$="y" THEN LPRINT "VN      DEL"
1025 IF P$="y" OR P$="Y" THEN LPRINT USING "#.###   ";VN,DEL
1040 PRINT "INTERVAL     NUMBER OF REPORTS" : PRINT USING "##          ";N,M
1045 IF P$="Y" OR P$="y" THEN LPRINT "INTERVAL      NUMBER OF REPORTS"
1046 IF P$ = "Y" OR P$ = "y" THEN LPRINT USING "##        ";N,M
1060 PRINT " RADIUS  ANGLE  VELOCITY ANGLE    x        y     z       vz"
1070 IF (P$="Y") OR (P$="y") THEN LPRINT "  RADIUS    ANGLE    VELOCITY   ANGLE3
2000 '3
2010 ' Calculate increments in position and velocity using magnetic
2011 ' force law and kinematics.
2015 I=0
2020 ' Calculate position, B and v at half-time-step
2021 ZTEMP = Z +VZ*DEL/2
2022 XTEMP = X +VX*DEL/2
2023 YTEMP = Y+VY*DEL/2
2026 BZ = 1 + ZTEMP/5
2027 BX = -(XTEMP+1)/10
2028 BY = -YTEMP/10
2029 VXT = VX+AX*DEL/2
2030 VYT = VY+AY*DEL/2
2031 VZT = VZ+AZ*DEL/2
2032 AX = VYT*BZ-VZT*BY  'acceleration
2034 AY = VZT*BX-VXT*BZ
2036 AZ = VXT*BY-VYT*BX
2055 'CALCULATE NEW VELOCITY COMPONENTS
2056 DVX = AX*DEL : DVY = AY*DEL: DVZ = AZ*DEL
2058 VX = VX +DVX : VY = VY + DVY: VZ = VZ+DVZ
2060 ' new distance from origin, and new angular coordinate.
2062 DX = VX*DEL:  DY = VY*DEL : DZ = VZ*DEL
2065 X=X + DX:  Y = Y+DY: Z = Z+DZ
2070 RQ=SQR(X*X+Y*Y) : THTQ=ATN(Y/X)
2075 IF X < 0! THEN THTQ = THTQ + PI
2080 ' NEW VELOCITY AND DIRECTION OF VELOCITY'
2090 VQ = SQR(VX*VX + VY*VY)
2095 V3 = SQR(VX*VX+VY*VY+VZ*VZ)
2100 ' change in radial velocity, new speed, and new direction of velocity.
2110 IF VX=0 THEN PHIQ = PI*((1!-SGN(VY))/2+.5) ELSE PHIQ = ATN(VY/VX)
2120 IF VX < 0! THEN PHIQ = PHIQ + PI
2160 '
3000 ' update variables.
3010 I=I+1 : RN=RQ : THTN=THTQ : VN=VQ : PHIN=PHIQ 
3060 IF I=>N GOTO 4020  
3070 GOTO 2021
3080 '
4000 ' Fill arrays for plotting and convert angles in radians to degrees
4010 ' for printing.
4020 J=J+1 : R(J)=RQ : TT(J)=THTQ : THT=THTQ*180/PI : V(J)=VQ : PH(J)=PHIQ 
4025 XX(J) = X:  YY(J) = Y : ZZ(J) = Z: VVZ(J) = VZ :VV3(J) = V3
4080 PHI=PHIQ*180/PI 
4090  PRINT USING " ###.## ";R(J),THT,V(J),PHI,XX(J),YY(J),ZZ(J),VVZ(J),VV3(J)
4100 IF (P$="Y") OR (P$="y") THEN LPRINT USING " ###.###  ";R(J),THT,V(J),PHI 
4110 '
4150 LLN = LLN + 1
4200  IF LLN < 20 GOTO 5020
4250 PRINT "Hit any key to continue"
4300 LL$ = INKEY$: IF LL$ = "" THEN 4300
4350 LLN = 0
5000 ' If finished, plot, otherwise compute new increments.
5010 ' IF YOU DO NOT WISH TO PLOT RESULTS, REPLACE STATEMENT 5030 WITH END
5020 IF J < M GOTO 2015
5022 PRINT "Hit any key to plot results"
5024 L$ = INKEY$: IF L$ = "" THEN 5024
5030 ' Prepare screen for plot.
5040 SCREEN 2,0,0,0:CLS:KEY OFF 
5050 ' Label with initial data.
5060 PRINT "VZSTR    DEL" : PRINT USING "#.###   ";VZSTR,DEL 
5080 PRINT "INTERVAL     NUMBER OF REPORTS" : PRINT USING "###          ";N,M 
5100 PRINT "SCALE FACTOR" : PRINT USING "#.##";S 
5200 ' Set position of origin, convert to integer.
5210 XO=330  : IXC = CINT(XO)
5220 ' Mark position of origin.
5230 CIRCLE (IXC,100),5 : PSET (IXC,100)
5250 ' Initial position.
5260 IXZ=330 - 2*50*S: IYZ = 100
5300 ' Move from one position to the next, drawing orbit.
5310 FOR J=1 TO M STEP 1  
5320 IX(J) = IXZ : IY(J) = IYZ : XN=50*XX(J)*S
5340 IXN=2*CINT(XN)+330 : YN=50*YY(J)*S*7/8: IYN=100-CINT(YN)
5370 ' If point is off the page, skip to next point.3
5380 IF IXN=>640 OR IXN=<0 GOTO 5520 : IF IYN=<0 OR IYN=>200 GOTO 5520  
5400 LINE (IXZ,IYZ) - (IXN,IYN) : IXZ=IXN : IYZ = IYN : NEXT J 
5500 'Strike any key to draw velocity vectors.
5505 K$=INKEY$: IF K$="" THEN 5505
5510 VPL = -1*VANG -1  
5520 FOR J = 1 TO M STEP 1  
5530 IF PH(J) - VPL < VANG GOTO 5610
5540 VP = 30*V(J)*S : IV = CINT(VP) : IXZ = IX(J): IYZ = IY(J) 
5560 AV = PH(J)*180/PI : IAV = CINT(AV)-90 : IT = IAV-45 : IB = IAV+45  
5570 IF IAV<315 THEN GOTO 5580 ELSE IB=IB-360:IF IAV>360 THEN IAV=IAV-360  
5580 PSET(IXZ,IYZ) 
5590 DRAW "ta=iAV; U=IV; TA=IT;ND5 TA=IB;ND5 " 
5600 VPL = PH(J)
5610 NEXT J
5620 '
6000 ' Strike any key to erase display and end program.
6010 K$=INKEY$: IF K$="" THEN 6010  
6030 SCREEN 0,0,0,0: KEY ON 
6040 END 
